src/Elbotrade/Bundle/CatalogBundle/Entity/Catalog.php
<?php
namespace Elbotrade\Bundle\CatalogBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Gedmo\Mapping\Annotation as Gedmo;
use Gedmo\Translatable\Translatable;

/**
 * Class Catalog
 * @package Elbotrade\Bundle\CatalogBundle\Entity
 *
 * @ORM\Entity
 * @ORM\Table(name="elbo_catalog")
 */
class Catalog
{

    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;

    /**
     * @Gedmo\Translatable
     * @ORM\Column(type="text")
     */
    protected $name;

    /**
     * @ORM\Column(type="boolean")
     */
    protected $active;

    /**
     * @ORM\ManyToMany(targetEntity="Application\Sonata\MediaBundle\Entity\Media", cascade={"persist"})
     * @ORM\JoinTable(name="catalog_images",
     *     joinColumns={@ORM\JoinColumn(name="catalog_id", referencedColumnName="id")},
     *     inverseJoinColumns={@ORM\JoinColumn(name="image_id", referencedColumnName="id")}
     *     )
     */
    protected $images;

    /**
     * @ORM\ManyToOne(targetEntity="Application\Sonata\MediaBundle\Entity\Media", cascade={"persist"}, fetch="LAZY")
     * @ORM\JoinColumn(name="cover_id", referencedColumnName="id")
     */
    protected $cover;

    /**
     * @ORM\ManyToOne(targetEntity="Application\Sonata\MediaBundle\Entity\Media", cascade={"persist"}, fetch="LAZY")
     * @ORM\JoinColumn(name="pdf_id", referencedColumnName="id")
     */
    protected $pdf;

    /**
     * @Gedmo\Locale
     * Used locale to override Translation listener`s locale
     * this is not a mapped field of entity metadata, just a simple property
     */
    protected $locale;

    /**
     * @ORM\ManyToOne(targetEntity="Elbotrade\Bundle\CatalogBundle\Entity\CatalogCategory", inversedBy="catalogs", cascade={"persist"})
     * @ORM\JoinColumn(name="category_id", referencedColumnName="id")
     */
    protected $category;


    public function __toString()
    {
        return $this->name;
    }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->images = new \Doctrine\Common\Collections\ArrayCollection();
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set name
     *
     * @param string $name
     * @return Catalog
     */
    public function setName($name)
    {
        $this->name = $name;

        return $this;
    }

    /**
     * Get name
     *
     * @return string 
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set active
     *
     * @param boolean $active
     * @return Catalog
     */
    public function setActive($active)
    {
        $this->active = $active;

        return $this;
    }

    /**
     * Get active
     *
     * @return boolean 
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * Set locale
     *
     * @param string $locale
     * @return Catalog
     */
    public function setLocale($locale)
    {
        $this->locale = $locale;

        return $this;
    }

    /**
     * Get locale
     *
     * @return string 
     */
    public function getLocale()
    {
        return $this->locale;
    }

    /**
     * Add images
     *
     * @param \Application\Sonata\MediaBundle\Entity\Media $images
     * @return Catalog
     */
    public function addImage(\Application\Sonata\MediaBundle\Entity\Media $images)
    {
        $this->images[] = $images;

        return $this;
    }

    /**
     * Remove images
     *
     * @param \Application\Sonata\MediaBundle\Entity\Media $images
     */
    public function removeImage(\Application\Sonata\MediaBundle\Entity\Media $images)
    {
        $this->images->removeElement($images);
    }

    /**
     * Get images
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getImages()
    {
        return $this->images;
    }


    public function getFirstImage()
    {
        return $this->images->first();
    }

    /**
     * Set cover
     *
     * @param \Application\Sonata\MediaBundle\Entity\Media $cover
     * @return Catalog
     */
    public function setCover(\Application\Sonata\MediaBundle\Entity\Media $cover = null)
    {
        $this->cover = $cover;

        return $this;
    }

    /**
     * Get cover
     *
     * @return \Application\Sonata\MediaBundle\Entity\Media 
     */
    public function getCover()
    {
        return $this->cover;
    }

    /**
     * Set pdf
     *
     * @param \Application\Sonata\MediaBundle\Entity\Media $pdf
     * @return Catalog
     */
    public function setPdf(\Application\Sonata\MediaBundle\Entity\Media $pdf = null)
    {
        $this->pdf = $pdf;

        return $this;
    }

    /**
     * Get pdf
     *
     * @return \Application\Sonata\MediaBundle\Entity\Media 
     */
    public function getPdf()
    {
        return $this->pdf;
    }

    /**
     * Set category
     *
     * @param \Elbotrade\Bundle\CatalogBundle\Entity\CatalogCategory $category
     * @return Catalog
     */
    public function setCategory(\Elbotrade\Bundle\CatalogBundle\Entity\CatalogCategory $category = null)
    {
        $this->category = $category;

        return $this;
    }

    /**
     * Get category
     *
     * @return \Elbotrade\Bundle\CatalogBundle\Entity\CatalogCategory 
     */
    public function getCategory()
    {
        return $this->category;
    }

    /**
     * Set locale
     *
     * @param $locale
     */
    public function setTranslatableLocale($locale)
    {
        $this->locale = $locale;
    }
}

src/Elbotrade/Bundle/CatalogBundle/Controller/CatalogBackendController.php
<?php
namespace Elbotrade\Bundle\CatalogBundle\Controller;

use Elbotrade\Bundle\CatalogBundle\Controller\CatalogController as CatalogController;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Component\HttpFoundation\Request;

class CatalogBackendController extends CatalogController
{

    /**
     * @Route("/elbotrade/catalog/backend/list", name="elbotrade_catalog_backend_list")
     * @Template()
     */
    public function indexAction()
    {

        return parent::indexAction(); // TODO: Change the autogenerated stub
    }

    /**
     * @Route("/elbotrade/catalog/backend/show/{id}", name="elbotrade_catalog_backend_show")
     * @Template()
     */
    public function showAction($id)
    {
        return parent::showAction($id); // TODO: Change the autogenerated stub
    }

    /**
     * @param Request $request
     * @param $id
     * @Route("/elbotrade/catalog/backend/update/{id}", name="elbotrade_catalog_backend_update")
     * @Template("ElbotradeCatalogBundle:CatalogBackend:update.html.twig")
     * @return array|\Symfony\Component\HttpFoundation\RedirectResponse
     */
    public function updateAction(Request $request, $id)
    {

        $editId = $request->get('editId');
        if (!preg_match('/^\d+$/', $editId)) {
            $editId = sprintf('%09d', mt_rand(0, 1999999999));
        }
        $existingFiles = $this->get('punk_ave.file_uploader')->getFiles(array('folder' => 'tmp/attachments/' . $editId));

        $catalogFinder = $this->get('elbotrade.catalog_bundle.catalog_finder');

        $catalog = $catalogFinder->findCatalog($id);

        $form = $this->createForm(
            $this->get('elbotrade_catalog.catalog.form.type'), null, ['action' => $this->generateUrl('elbotrade_catalog_backend_update', ['editId' => $editId, 'id' => $id])]
        );

        if ($request->isMethod(Request::METHOD_POST)) {
            $catalogManager = $this->get('elbotrade.catalog.catalog_manager');
            if ($catalogId = $catalogManager->handleCatalogForm($form, $catalog, $request, $this->get('sylius.context.locale')->getCurrentLocale())) {
                $response = $this->redirect($this->generateUrl('elbotrade_catalog_backend_show', ['id' => $catalogId]));
                return $response;
            }
        }

        $form->setData($catalog);

        return [
            'editId'=> $editId,
            'existingFiles' => $existingFiles,
            'form' => $form->createView(),
            'images' => $catalog->getImages() ? $catalog->getImages() : [],
            'cover' => $catalog->getCover(),
        ];
    }

    /**
     * @param Request $request
     * @return array
     * @Route("/elbotrade/catalog/backend/create", name="elbotrade_catalog_backend_create")
     * @Template();
     */
    public function createAction(Request $request)
    {

        $editId = $request->get('editId');
        if (!preg_match('/^\d+$/', $editId)) {
            $editId = sprintf('%09d', mt_rand(0, 1999999999));
        }
//        $existingFiles = $this->get('punk_ave.file_uploader')->getFiles(array('folder' => 'tmp/attachments/' . $editId));

        $catalog = $this->get('elbotrade.catalog.catalog_manager')->createCatalog();

        $form = $this->createForm(
            $this->get('elbotrade_catalog.catalog.form.type'), null, ['action' => $this->generateUrl('elbotrade_catalog_backend_create')]
        );

        if ($request->isMethod(Request::METHOD_POST)) {
            $catalogManager = $this->get('elbotrade.catalog.catalog_manager');
            if ($catalogId = $catalogManager->handleCatalogForm($form, $catalog, $request, $this->get('sylius.context.locale')->getCurrentLocale())) {
                $response = $this->redirect($this->generateUrl('elbotrade_catalog_backend_list'));
                return $response;
            }
        }

        return [
            'editId'=> $editId,
//            'existingFiles' => $existingFiles,
            'form' => $form->createView(),
        ];
    }

    /**
     * @Route("/elbotrade/catalog/backend/delete/{id}", name="elbotrade_catalog_backend_delete")
     */
    public function deleteAction($id)
    {

        $catalog = $this->get('elbotrade.catalog_bundle.catalog_finder')->findCatalog($id);

        $this->getDoctrine()->getManager()->remove($catalog);
        $this->getDoctrine()->getManager()->flush();

        $flashService = $this->get('elbotrade_product.services.flash_service');

        $flashService->setFlash('success', 'Catalog Deleted');

        return $this->redirect($this->generateUrl('elbotrade_catalog_backend_list'));
    }

    /**
     * @Route("upload", name="multi-upload")
     */
    public function multiUploadAction(Request $request)
    {
        $editId = $request->get('editId');

        $this->get('elbotrade.catalog.file_uploader')->handleFileUpload(array('folder' => 'tmp/attachments/' . $editId));
    }
}

src/Elbotrade/Bundle/CatalogBundle/Resources/views/CatalogBackend/create.html.twig
{% extends 'SyliusWebBundle:Backend:layout.html.twig' %}

{% from 'SyliusResourceBundle:Macros:actions.html.twig' import create %}

{% block topbar %}
    <ol class="breadcrumb">
        <li>{{ 'sylius.breadcrumb.assortment'|trans }}</li>
        <li><a href="{{ path('elbotrade_catalog_backend_list') }}">Catalogs</a></li>
        <li>{{ 'sylius.breadcrumb.new'|trans }}</a></li>
    </ol>
{% endblock %}

{% block content %}
    <div class="page-header">
        <h1><i class="glyphicon glyphicon-plus"></i> New catalog</h1>
    </div>

    {{ form_errors(form) }}

    {% include "@ElbotradeCatalog/Partial/multi_upload.html.twig" %}
    <form id="createCatalog" name="createCatalog" action="{{ path('elbotrade_catalog_backend_create', {editId: editId}) }}" method="post" class="form-horizontal" {{ form_enctype(form) }} novalidate>
        {{ form_row(form.name) }}
        {{ form_row(form.active) }}
        {{ form_row(form.locale) }}
        {{ form_row(form.category) }}
        {{ form_row(form.pdf, {'accept': 'application/pdf,application/vnd.ms-excel'}) }}
        Prvá stránka PDF súboru sa bude používať ako tapeta.
        {{ create() }}
    </form>
{% endblock %}

{% block javascripts %}
    {{ parent() }}

    <script src="{{ asset('bundles/elbotradecatalog/js/underscore-min.js') }}"></script>
    <script src="//ajax.googleapis.com/ajax/libs/jqueryui/1.11.1/jquery-ui.min.js"></script>
    <script src="{{ asset('bundles/punkavefileuploader/js/jquery.fileupload.js') }}"></script>
    <script src="{{ asset('bundles/punkavefileuploader/js/jquery.iframe-transport.js') }}"></script>
    <script src="{{ asset('bundles/punkavefileuploader/js/FileUploader.js') }}"></script>

    <script type="text/javascript">
        function readURL(input) {
            if (input.files && input.files[0]) {
                var reader = new FileReader();

                reader.onload = function (e) {
                    $('#image-preview')
                            .attr('src', e.target.result)
                            .width(100)
                            .height(100);
                };

                reader.readAsDataURL(input.files[0]);
            }
        }

        function openBrowser() {
            $('#createCatalog input[type=file]').click();
        }

        $(function() {
            new PunkAveFileUploader({
                'uploadUrl': {{ path('multi-upload', {editId: editId}) | json_encode | raw }},
                {#'viewUrl': {{ ('/uploads/tmp/attachments/' ~ editId) | json_encode | raw }},#} {# sluzi na vyhladavanie uz uploadnutych fotkach #}
                'el': '.file-uploader',
                'existingFiles': {{ punkave_get_files('tmp/attachments/' ~ editId) | json_encode | raw }},
                'delaySubmitWhileUploading': '#galleryUpload'
            });
        });

    </script>
{% endblock %}

src/Elbotrade/Bundle/CatalogBundle/Resources/views/CatalogBackend/index.html.twig
{% extends 'SyliusWebBundle:Backend:layout.html.twig' %}

{% import 'SyliusResourceBundle:Macros:buttons.html.twig' as buttons %}
{% from 'SyliusWebBundle:Backend/Macros:misc.html.twig' import pagination %}
{% from '@ElbotradeCatalog/CatalogBackend/macros.html.twig' import list %}

{% block topbar %}
    <ol class="breadcrumb">
        <li>{{ 'sylius.breadcrumb.assortment'|trans }}</li>
        <li>Catalogs</li>
    </ol>
{% endblock %}

{% block content %}
    <div class="page-header">
        <div class="actions-menu">
            {{ buttons.create(path('elbotrade_catalog_backend_create'), 'Create Catalog') }}
        </div>
        <h1><i class="glyphicon glyphicon-th-list"></i>  Catalogs <small>Index of all catalogs in your store</small></h1>
    </div>

    {#{% render(controller('sylius.controller.backend.form:filterAction', {'type': 'sylius_product_filter', 'template': 'SyliusWebBundle:Backend/Product:filterForm.html.twig'})) %}#}

    {{ pagination(catalogs) }}
    {{ list(catalogs) }}
    {{ pagination(catalogs) }}

{% endblock %}

src/Elbotrade/Bundle/CatalogBundle/Resources/views/CatalogBackend/macros.html.twig
{% macro list(catalogs) %}

    {% import 'SyliusResourceBundle:Macros:buttons.html.twig' as buttons %}
    {% import 'SyliusWebBundle:Backend/Macros:alerts.html.twig' as alerts %}

    {% if catalogs|length > 0 %}
        <table class="sylius-products-table table table-bordered">
            <thead>
            <tr>
                <th class="id">{{ sylius_resource_sort('id', '#id') }}</th>
                <th class="info">{{ sylius_resource_sort('name', 'Name') }}</th>
                <th class="info">{{ sylius_resource_sort('active', 'Active') }}</th>
                <th class="updated-at">{{ sylius_resource_sort('locale', 'Locale') }}</th>
                <th class="info">{{ sylius_resource_sort('category', 'Category') }}</th>
                <th></th>
            </tr>
            </thead>
            <tbody>
            {% for catalog in catalogs %}
                <tr id="{{ catalog.id }}">
                    <td class="id">
                        {{ catalog.id }}
                    </td>
                    <td class="info">
                        <div class="media">
                            <a href="{{ path('elbotrade_catalog_backend_show', {'id': catalog.id}) }}" class="pull-left"
                               title="Details">
                                {% if catalog.firstImage %}
                                    {% thumbnail catalog.firstImage, 'small' %}
                                {% else %}
                                    <img src="http://placehold.it/50x40" alt="" class="imgmedia-object" />
                                {% endif %}
                            </a>
                            <div class="media-body">
                                <h5 class="media-heading">
                                    <a class="name"
                                       href="{{ path('elbotrade_catalog_backend_show', {'id': catalog.id}) }}"
                                       title="Details">
                                        {{ catalog.name }}
                                    </a>
                                </h5>
                            </div>
                        </div>
                    </td>
                    <td class="info">
                        <em>{% if catalog.active == true %}<span class="glyphicon glyphicon-ok"></span>{% else %}<span class="glyphicon glyphicon-remove"></span>{% endif %}</em>
                    </td>
                    <td class="info">
                        <em>{{ catalog.locale }}</em>
                    </td>
                    <td class="info">
                        <em>{% if catalog.category is not null %}<a href="{{ path('elbotrade_catalog_category_backend_show', {'id': catalog.category.id}) }}">{{ catalog.category }}</a>{% endif %}</em>
                    </td>
                    <td class="center-text">
                        {{ buttons.edit(path('elbotrade_catalog_backend_update', {'id': catalog.id})) }}
                        {{ buttons.delete(path('elbotrade_catalog_backend_delete', {'id': catalog.id})) }}
                    </td>
                </tr>
            {% endfor %}
            </tbody>
        </table>
    {% else %}
        {{ alerts.info('Žádny katalog k zobrazení.') }}
    {% endif %}

{% endmacro %}

src/Elbotrade/Bundle/CatalogBundle/Resources/views/CatalogBackend/show.html.twig
{% extends 'SyliusWebBundle:Backend:layout.html.twig' %}

{% import 'SyliusResourceBundle:Macros:buttons.html.twig' as buttons %}
{% import 'SyliusWebBundle:Backend/Macros:alerts.html.twig' as alerts %}
{% import 'SyliusWebBundle:Backend/Macros:misc.html.twig' as misc %}

{% block topbar %}
    <ol class="breadcrumb">
        <li>{{ 'sylius.breadcrumb.assortment'|trans }}</li>
        <li><a href="{{ path('elbotrade_catalog_backend_list') }}">Catalogs</a></li>
        <li>{{ catalog.name }}</li>
    </ol>
{% endblock %}

{% block content %}
    <div class="page-header">
        <div class="actions-menu">
            {{ buttons.manage(path('elbotrade_catalog_backend_list'), 'Manage Catalogs') }}
            {{ buttons.edit(path('elbotrade_catalog_backend_update', {'id': catalog.id})) }}
            {{ buttons.delete(path('elbotrade_catalog_backend_delete', {'id': catalog.id}), null, false, true) }}
        </div>
        <h1>
            <i class="glyphicon glyphicon-info-sign"></i> Catalog Details {{ catalog.name }}
        </h1>
    </div>

    <div class="row">
        <div class="col-md-6">
            <table class="table table-bordered">
                <thead>
                <tr>
                    <th colspan="2">{{ 'sylius.order.general_info'|trans }}</th>
                </tr>
                </thead>
                <tbody>
                <tr>
                    <td><strong>{{ 'sylius.shipment.id'|trans }}</strong></td>
                    <td>{{ catalog.id }}</td>
                </tr>
                <tr>
                    <td>{{ 'sylius.product.name'|trans }}</td>
                    <td>{{ catalog.name }}</td>
                </tr>
                <tr>
                    <td>Active</td>
                    <td>{{ catalog.active }}</td>
                </tr>
                <tr>
                    <td>Locale</td>
                    <td>{{ catalog.locale }}</td>
                </tr>
                <tr>
                    <td>Catagory</td>
                    <td>{{ catalog.category }}</td>
                </tr>
                </tbody>
            </table>
        </div>

        <div class="col-md-6">
            {% for page in catalog.images %}
                {% thumbnail page, 'small' %}
            {% endfor %}
        </div>
    </div>

    <hr>

{% endblock %}

src/Elbotrade/Bundle/CatalogBundle/Resources/views/CatalogBackend/update.html.twig
{% extends 'SyliusWebBundle:Backend:layout.html.twig' %}

{% from 'SyliusResourceBundle:Macros:actions.html.twig' import update %}

{% block topbar %}
    <ol class="breadcrumb">
        <li>{{ 'sylius.breadcrumb.assortment'|trans }}</li>
        <li><a href="{{ path('elbotrade_catalog_backend_list') }}">Catalogs</a></li>
        <li>{{ 'sylius.breadcrumb.update'|trans }}</a></li>
    </ol>
{% endblock %}

{% block content %}
    <div class="page-header">
        <h1><i class="glyphicon glyphicon-plus"></i> Update catalog</h1>
    </div>

    {{ form_errors(form) }}

    <div class="row">
        {% include "@ElbotradeCatalog/Partial/multi_upload.html.twig" %}
        {{ form_start(form, {'class': 'form-horizontal', 'method': 'POST', 'name': 'crateCatalog', 'attr': {'id': 'updateCatalog'}}) }}
        <div class="col-md-6">
            <table class="table table-bordered">
                <thead>
                <tr>
                    <th colspan="2">{{ 'sylius.order.general_info'|trans }}</th>
                </tr>
                </thead>
                <tbody>
                <tr>
                    <td>{{ form_row(form.name) }}</td>
                </tr>
                <tr>
                    <td>{{ form_row(form.active) }}</td>
                </tr>
                <tr>
                    <td>{{ form_row(form.locale) }}</td>
                </tr>
                <tr>
                    <td>{{ form_row(form.category) }}</td>
                </tr>
                </tbody>
            </table>
        </div>

        <div class="col-md-6">
            <table class="table table-bordered">
            <thead>
                <tr>
                    <th colspan="2">Media</th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>{% for image in images %}
                            <a href="{% path image, 'big' %}" class="images">{% thumbnail image, 'small' %}</a>
                        {% endfor %}
                        <div class="file-uploader"></div>
                    </td>
                </tr>
                <tr>
                    <td>{{ form_row(form.cover) }}</td>
                </tr>
            </tbody>
        </table>
        </div>
    </div>
    <div class="row">
        <div class="col-md-12">
            {{ update() }}
        </div>
        {{ form_end(form) }}
    </div>
{% endblock %}

{% block javascripts %}
    {{ parent() }}

    <script src="{{ asset('bundles/elbotradecatalog/js/underscore-min.js') }}"></script>
    <script src="//ajax.googleapis.com/ajax/libs/jqueryui/1.11.1/jquery-ui.min.js"></script>
    <script src="{{ asset('bundles/punkavefileuploader/js/jquery.fileupload.js') }}"></script>
    <script src="{{ asset('bundles/punkavefileuploader/js/jquery.iframe-transport.js') }}"></script>
    <script src="{{ asset('bundles/punkavefileuploader/js/FileUploader.js') }}"></script>
    <script src="{{ asset('bundles/elbotradeproduct/js/jquery.colorbox-min.js') }}"></script>
    <script src="{{ asset('bundles/elbotradeproduct/stylesheets/colorbox.css') }}"></script>

    <script type="text/javascript">
        function readURL(input) {
            if (input.files && input.files[0]) {
                var reader = new FileReader();

                reader.onload = function (e) {
                    $('#image-preview')
                            .attr('src', e.target.result)
                            .width(100)
                            .height(100);
                };

                reader.readAsDataURL(input.files[0]);
            }
        }

        function openBrowser() {
            $('#updateCatalog input[type=file]').click();
        }

        $(function() {
            new PunkAveFileUploader({
                'uploadUrl': {{ path('multi-upload', {editId: editId}) | json_encode | raw }},
                {#'viewUrl': {{ ('/uploads/tmp/attachments/' ~ editId) | json_encode | raw }},#} {# sluzi na vyhladavanie uz uploadnutych fotkach #}
                'el': '.file-uploader',
                'existingFiles': {{ punkave_get_files('tmp/attachments/' ~ editId) | json_encode | raw }},
                'delaySubmitWhileUploading': '#galleryUpload'
            });
        });

        $(document).ready(function() {
            $(".images").colorbox({ rel: 'images'});
        })
    </script>
{% endblock %}